///////////////////////////////////////////////////////////
//                 TConsUtilServiceClass                 //
//      ""     //
//                Copyright (C) 2007 Sagrer              //
//                             //
//                      LGPL v2.1                        //
//                                                       //
//                    0.1                    //
//                                                       //
//                  sagrer@yandex.ru                     //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ConsUtilServiceClass;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, forms;

type
  TConsUtilServiceClass = class        //   ""  
  private
  protected
    // .
    ProcessFurther : boolean;          //   .
    // .
  public
    //
    DoShowHelp : boolean;              //  .
    DoShowVersion : boolean;           //    .
    DoSilent : boolean;                //    .
    DoPause : boolean;                 //        .

    //-...
    constructor Create; virtual;
    destructor Destroy; override;

    // ...
    procedure ProcessParameters;  virtual;     //   .
    procedure DoWork;             virtual;     //   %).
    procedure ShowHelp;           virtual;     // .
    procedure ShowVersion;        virtual;     // .
    procedure ShowOptions;        virtual;     //  ,       
    procedure ShowDescription;    virtual;     //        .
  end;

implementation

/////////////////////////////////////////////
//          TConsUtilServiceClass          //
/////////////////////////////////////////////

//-----------------------------------------//
//        -...      //
//-----------------------------------------//

constructor TConsUtilServiceClass.Create;
begin
  //  ...
  ProcessFurther := true;
  DoShowHelp := false;
  DoShowVersion := false;
  DoSilent := false;
  DoPause := false;

  //   ...
end;

destructor TConsUtilServiceClass.Destroy;
begin
  // 

  //  
  inherited;
end;

//------------------------------------------//
//              ...             //
//------------------------------------------//

procedure TConsUtilServiceClass.ProcessParameters;
//   .
begin
  //   ...

  if Application.HasOption('h') or Application.HasOption('help') or Application.HasOption('?') then begin
    // .
    DoShowHelp := true;
  end;

  if Application.HasOption('v') or Application.HasOption('version') then begin
    //    .
    DoShowVersion := true;
  end;

  if Application.HasOption('s') or Application.HasOption('silent') then begin
    //   .
    DoSilent := true;
  end;

  if Application.HasOption('p') or Application.HasOption('pause') then begin
    //    
    DoPause := true;
  end;
end;

procedure TConsUtilServiceClass.DoWork;
//   %).
begin
  //     -    ProcessFurther := false
  //    .

  //.
  if (DoShowHelp = true) and (ProcessFurther = true) then begin
    //  
    ProcessFurther := false;
    // ...
    ShowHelp;
  end;

  // .
  if (DoShowVersion = true) and (ProcessFurther = true) then begin
    //  
    ProcessFurther := false;
    // ...
    ShowVersion;
  end;

  //       -    ....
  // .       override    .
  //if ProcessFurther = true then begin
    ////  
    //ProcessFurther := false;
    ////....

  //end;

end;

procedure TConsUtilServiceClass.ShowHelp;
// .
begin
  // .
  Writeln();
  //  ...
  ShowVersion();
  // .
  Writeln();
  //
  ShowDescription();
  // .
  Writeln();
  //   ...
  Writeln('Usage: '+ExtractFileName(Application.ExeName)+ ' [options]');
  Writeln();
  //   ...
  ShowOptions;
  // .
  Writeln();
end;

procedure TConsUtilServiceClass.ShowVersion;
// .
begin
  //. .
end;

procedure TConsUtilServiceClass.ShowOptions;
//  ,       
begin
  Writeln('Options:');
  Writeln('          -h, --help, -? : shows this help message.');
  Writeln('          -v, --version : shows utility''s version number and copyright.');
  Writeln('          -s, --silent : works in silent mode (without any questions).');
  Writeln('                         By default works in interactive mode and can ');
  Writeln('                         ask anything.');
  Writeln('          -p, --pause : waits until User press Enter after finishing all work.');
end;

procedure TConsUtilServiceClass.ShowDescription;
//        .
begin
  //. .
end;

end.

